/*
 * biblioteka.c
 *
 *  Created on: 6.07.2016
 *  Author: Mateusz Kuc
 *  Email: kucmateusz92@gmail.com
 */
#include "stm32f0xx.h"
#include "stm32f0_discovery.h"
#include "biblioteka.h"

void CLK_inicjalizacja(void)
{
	RCC -> AHBENR |= RCC_AHBENR_GPIOAEN|RCC_AHBENR_GPIOBEN|RCC_AHBENR_GPIOCEN;//zegar dla portu B i C
	RCC -> APB2ENR |= RCC_APB2ENR_ADC1EN|RCC_APB2ENR_TIM1EN;//odblokowanie zegara ADC i Timera1
	RCC -> APB1ENR |= RCC_APB1ENR_TIM2EN;//Timer2
	__DSB();//czekam na ustabilizowanie zegarow
}

void GPIO_inicjalizacja(void)
{
	//ustawienie 8 wyjsc odpowiadajacych za wybór kolumny
	GPIOA -> MODER |= GPIO_MODER_MODER0_0|GPIO_MODER_MODER1_0|GPIO_MODER_MODER2_0|GPIO_MODER_MODER3_0;
	GPIOA -> MODER |= GPIO_MODER_MODER4_0|GPIO_MODER_MODER5_0|GPIO_MODER_MODER6_0|GPIO_MODER_MODER7_0;
	GPIOA -> PUPDR |= GPIO_PUPDR_PUPDR0_0|GPIO_PUPDR_PUPDR1_0|GPIO_PUPDR_PUPDR2_0|GPIO_PUPDR_PUPDR3_0;
	GPIOA -> PUPDR |= GPIO_PUPDR_PUPDR4_0|GPIO_PUPDR_PUPDR5_0|GPIO_PUPDR_PUPDR6_0|GPIO_PUPDR_PUPDR7_0;
	GPIOA -> BRR = 0xFF;//wyłączam wszystkie warstwy
	//ustawienie 8wyjśc, które będą wejsciami rejestrów
	GPIOB -> MODER |= GPIO_MODER_MODER0_0|GPIO_MODER_MODER1_0|GPIO_MODER_MODER2_0|GPIO_MODER_MODER3_0;
	GPIOB -> MODER |= GPIO_MODER_MODER4_0|GPIO_MODER_MODER5_0|GPIO_MODER_MODER6_0|GPIO_MODER_MODER7_0;
	GPIOB -> MODER |= GPIO_MODER_MODER8_0;//odblokowanie wyjścia wszystkich rejestrów, aktywne zerem
	GPIOB -> PUPDR |= GPIO_PUPDR_PUPDR0_0|GPIO_PUPDR_PUPDR1_0|GPIO_PUPDR_PUPDR2_0|GPIO_PUPDR_PUPDR3_0;
	GPIOB -> PUPDR |= GPIO_PUPDR_PUPDR4_0|GPIO_PUPDR_PUPDR5_0|GPIO_PUPDR_PUPDR6_0|GPIO_PUPDR_PUPDR7_0;
	GPIOB -> PUPDR |= GPIO_PUPDR_PUPDR8_0;//odblokowanie wyjścia wszystkich rejestrów
	//ustawienie 8 wyjsc, którymi wybieram rejestr zewnetrzny, linie zegarowe dla nich
	GPIOC -> MODER |= GPIO_MODER_MODER1_0|GPIO_MODER_MODER2_0|GPIO_MODER_MODER3_0|GPIO_MODER_MODER4_0;
	GPIOC -> MODER |= GPIO_MODER_MODER5_0|GPIO_MODER_MODER6_0|GPIO_MODER_MODER7_0|GPIO_MODER_MODER8_0;
	GPIOC -> PUPDR |= GPIO_PUPDR_PUPDR1_0|GPIO_PUPDR_PUPDR2_0|GPIO_PUPDR_PUPDR3_0|GPIO_PUPDR_PUPDR4_0;
	GPIOC -> PUPDR |= GPIO_PUPDR_PUPDR5_0|GPIO_PUPDR_PUPDR6_0|GPIO_PUPDR_PUPDR7_0|GPIO_PUPDR_PUPDR8_0;

	GPIOC -> MODER |= GPIO_MODER_MODER0;//PC0 jako pin analogowy
}

void ADC_ustaw(void)
{
	ADC1->CR |= ADC_CR_ADCAL;
	while((ADC1->CR & ADC_CR_ADCAL));
	ADC1->CHSELR |= ADC_CHSELR_CHSEL10;
	ADC1->CR |= ADC_CR_ADEN;
	while(!((ADC1->ISR) & ADC_ISR_ADRDY));
	__DSB();//czekam na ustabilizowanie zegarow
}

void TIMER_ustaw(void)
{
	TIM1 -> PSC = 10;//preskaler
	TIM1 -> ARR = 5712;//przeładowanie
	TIM1 -> DIER = TIM_DIER_UIE;//generator przerwań przy odświeżaniu licznika
	TIM1 -> CR1 = TIM_CR1_CEN;//włączenie licznika

	TIM2 -> PSC = 4;//preskaler
	TIM2 -> ARR = 15624;//przeładowanie
	TIM2 -> DIER = TIM_DIER_UIE;//generator przerwań przy odświeżaniu licznika
	TIM2 -> CR1 = TIM_CR1_CEN;//włączenie licznika
}

uint16_t read_ADC(void)
{
	ADC1->CR |= ADC_CR_ADSTART;
	while(!((ADC1->ISR) & (ADC_ISR_EOC)));
	return  (uint16_t) ADC1->DR;
}

void ile_led(uint8_t i)
{
	switch(i)//ile diod ma się świecic
	{
		case 0:
		{
			GPIOB -> BRR = 0x00FF;
			break;
		}
		case 1:
		{
			GPIOB -> BSRR = 0x0001;
			break;
		}
		case 2:
		{
			GPIOB -> BSRR = 0x0003;
			break;
		}
		case 3:
		{
			GPIOB -> BSRR = 0x0007;
			break;
		}
		case 4:
		{
			GPIOB -> BSRR = 0x000F;
			break;
		}
		case 5:
		{
			GPIOB -> BSRR = 0x001F;
			break;
		}
		case 6:
		{
			GPIOB -> BSRR = 0x003F;
			break;
		}
		case 7:
		{
			GPIOB -> BSRR = 0x007F;
		break;
		}
		case 8:
		{
			GPIOB -> BSRR = 0x00FF;
			break;
		}
		default:
		{
			GPIOB -> BSRR = GPIO_BSRR_BS_8;
			break;
		}
	}
}

void oswietl(uint8_t i, uint8_t ile_diod)
{
	GPIOB -> BSRR = GPIO_BSRR_BS_8;//wylacz wyświetlacz
	ile_led(0);//zerujemy rejestry
	//wybierz kolumne i ustaw tam 1, muszę o jeden bit dalej się przesunąc bo zaczynam od PC1 a nie PC0
	//na PC0 jest ADC!!
	GPIOC -> BRR = (1<<(i+1));//zmien na 0 w kolumnie, nastepuje zapis do rejestru ile ma byc diod
	ile_led(ile_diod);//ustaw ile ma diod zaswiecic sie
	GPIOC -> BSRR = (1<<(i+1));//wybierz kolumne i ustaw tam 1
	//zmien na 0 w kolumnie, nastepuje zapis do rejestru ile ma byc diod
	GPIOB -> BRR = GPIO_BSRR_BS_8;//uruchom wyswietlanie
}

void szescian(uint8_t warstwa, uint8_t kolumny, uint8_t diody)
{
	GPIOA -> BRR = 0xFF;//wyłącz warstwy
	oswietl(kolumny,diody);//wpisujemy wartosc do rejestru, okreslam ile ma diod swiecic i gdzie na warstwie
	GPIOA -> BSRR = (1<<warstwa);//wybieram warstwe
}
