/**
  ******************************************************************************
  * @file    main.c
  * @author  Ac6
  * @version V1.0
  * @date    6.07.2016
  * @brief   Default main function.
  * @email	 kucmateusz92@gmail.com
  ******************************************************************************
*/


#include "stm32f0xx.h"
#include "stm32f0_discovery.h"
#include "biblioteka.h"
//[warstwa][kolumna]
volatile uint8_t adc_wynik[8][8]={
		{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0},{0,0,0,0,0,0,0,0}};
volatile uint16_t adc_bufor=0;
volatile uint8_t krazaca_kolumna=0;
volatile uint8_t ktore_ADC_w=0;
volatile uint8_t ktore_ADC_k=0;
volatile uint8_t i=0;
volatile uint8_t ktora_warstwa=0;

int main(void)
{
	CLK_inicjalizacja();
	GPIO_inicjalizacja();

	ADC_ustaw();
	TIMER_ustaw();

	for(i=0; i<8; i++)//czyszcze wyswietlacz
	{
		oswietl(i,0);
	}

	//odblokowanie przerwań w NVIC
	NVIC_EnableIRQ(TIM1_BRK_UP_TRG_COM_IRQn);
	NVIC_EnableIRQ(TIM2_IRQn);

	for(;;);
}

void TIM1_BRK_UP_TRG_COM_IRQHandler(void)//przerwanie timera
{
	if(TIM1 -> SR & TIM_SR_UIF)
	{
		TIM1 -> SR = ~TIM_SR_UIF;
		GPIOA -> BRR = GPIO_BRR_BR_1;
		szescian(ktora_warstwa, krazaca_kolumna, adc_wynik[ktora_warstwa][krazaca_kolumna]);
		krazaca_kolumna++;
		if(krazaca_kolumna==8)
		{
			ktora_warstwa++;
			ktora_warstwa%=8;
			krazaca_kolumna=0;
		}
		GPIOA -> BSRR = GPIO_BSRR_BS_1;
	}
}

void TIM2_IRQHandler(void)//do obsługi ADC
{
	if(TIM2 -> SR & TIM_SR_UIF)
	{
		TIM2 -> SR = ~TIM_SR_UIF;
		adc_bufor=read_ADC();
		adc_wynik[ktore_ADC_w][ktore_ADC_k]=adc_bufor%9;
		ktore_ADC_w++;
		if(ktore_ADC_w==8)
		{
			ktore_ADC_k++;
			ktore_ADC_k%=8;
			ktore_ADC_w=0;
		}
	}
}
